#!/usr/bin/perl
# wipe.pl tchrist@colorado.edu

#$SYS_fsync=95;	# comment out this line if you're not sure
$DEF_BS = 16 * 2 ** 10;
$VERSION="1.0perl";

$errs=0;
if ($ARGV[0] =~ /^-/) {
    require 'getopts.pl';
    &Getopts('idhv') || &usage;
}
$opt_h && &help;
@ARGV || &usage;
$opt_v && &vers;
if ($opt_i) {
    open(TTY, "+</dev/tty") || die "can't open /dev/tty: $!";
    select((select(TTY),$|=1)[0]);
} 

FILE: foreach $file (@ARGV) {
    if ($opt_i) {
	print TTY "wipe $file? ";
	next FILE unless <TTY> =~ /^\s*y/i;
    } 
    -e $file			|| &oops("non-existent\n");
    -f _			|| (warn("not a regular file"),$errs++,next);
    open (F, "+<$file")		|| &oops($file);
    $bs = (stat(_))[11];
    $BUFSIZ = $bs > $DEF_BS ? $bs : $DEF_BS;
    $BUF = "\0" x $BUFSIZ;
    $size = -s F;
    $count = 0;
    while ($count+$BUFSIZ < $size) {
	(syswrite(F, $BUF, $BUFSIZ) == $BUFSIZ)
				|| &oops("write");
	$count += $BUFSIZ;
    } 
    ($count < $size) && (syswrite(F, $BUF, $size-$count)) == ($size-$count)
				|| &oops("write");
    &fsync(F)			|| &oops("fsync");
    close(F)			|| &oops("close");
    unlink($file)		|| &oops("unlink")	if $opt_d;
}
exit ($errs != 0);

sub oops { warn "$0: $file: $_[0]: $!\n"; $errs++; next FILE; } 
sub vers { warn "wipe version: $VERSION\n"; }
sub usage { &vers; die "Usage: wipe [-i] [-d] [-h] [-v] <file1> <file2> ...\n"; } 
sub help {
    warn <<"EOF";
$0 understands these options:

    -d means actually delete the file(s)
    -i means ask before wiping each file
    -h prints this message
    -v prints the version

EOF
    &usage();
} 

sub fsync { 
    local($file) = shift || die "fsync: expected arg";
    unless (defined $SYS_fsync) {
	local($_);
	if (open(S,"< /usr/include/sys/syscall.h")) {
	    while (<S>) {
		if (/#\s*define\s+SYS_fsync\s*(\d+)/) {
		    $SYS_fsync = $1;
		    last;
		} 
	    } 
	    $SYS_fsync = 0 unless defined $SYS_fsync;
	    close S;
	} 
    } 
    $SYS_fsync ? !syscall($SYS_fsync,fileno($file)) : 1; 
}
__END__
-- 
    Tom Christiansen      tchrist@cs.colorado.edu       
      "Will Hack Perl for Fine Food and Fun"
	Boulder Colorado  303-444-3212

